/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 * 
 * This software is a multi-platform and portable application based on 
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s 
 * possible to calculate indicators «RhoMéO» to monitor quality, 
 * fonctionalities and urban and agricultural pressures of wetlands. 
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.core.util;

import fr.cenra.rhomeo.core.RhomeoCore;
import java.nio.charset.StandardCharsets;
import java.security.GeneralSecurityException;
import java.security.SecureRandom;
import java.util.Base64;
import java.util.Optional;
import java.util.logging.Level;
import javax.crypto.Cipher;
import javax.crypto.KeyGenerator;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

/**
 *
 * @author Alexis Manin (Geomatys)
 */
public class SecretGenerator {

    private static SecretGenerator INSTANCE;

    private final Cipher cipher;
    private final Base64.Encoder encoder;
    private final Base64.Decoder decoder;
    private final KeyGenerator keyGen;
    private final SecureRandom sr;

    private SecretGenerator() throws GeneralSecurityException {
        cipher = Cipher.getInstance("Blowfish/CBC/PKCS5Padding");
        keyGen = KeyGenerator.getInstance("Blowfish");
        encoder = Base64.getEncoder().withoutPadding();
        decoder = Base64.getDecoder();
        sr = new SecureRandom();
    }

    public synchronized EncryptionResult encrypt(final String toEncrypt) throws GeneralSecurityException {
        keyGen.init(128);
        final byte[] keyBytes = keyGen.generateKey().getEncoded();
        if (keyBytes == null) {
            throw new GeneralSecurityException("No key can be generated for queried encryption.");
        }

        final byte[] srBytes = new byte[cipher.getBlockSize()];
        sr.nextBytes(srBytes);

        cipher.init(
                Cipher.ENCRYPT_MODE,
                new SecretKeySpec(keyBytes, "Blowfish"),
                new IvParameterSpec(srBytes)
        );

        return new EncryptionResult(
                encoder.encodeToString(cipher.doFinal(toEncrypt.getBytes(StandardCharsets.UTF_8))),
                keyBytes,
                srBytes
        );
    }

    public synchronized String decrypt(final String toDecrypt, final byte[] key, final byte[] rs) throws GeneralSecurityException {
        cipher.init(
                Cipher.DECRYPT_MODE,
                new SecretKeySpec(key, "Blowfish"),
                new IvParameterSpec(rs)
        );
        return new String(
                cipher.doFinal(decoder.decode(toDecrypt)),
                StandardCharsets.UTF_8
        );
    }

    public static final Optional<SecretGenerator> getInstance() {
        if (INSTANCE == null) {
            try {
                INSTANCE = new SecretGenerator();
            } catch (GeneralSecurityException e) {
                RhomeoCore.LOGGER.log(Level.WARNING, "Cannot initialize encryption management mechanism.", e);
            }
        }

        return Optional.ofNullable(INSTANCE);
    }
}
